<?php
/**
 * @file
 * Logic for warden output
 */

require_once ('warden_encryption.inc');

/**
 * Return JSON formatted module information.
 */
function warden_status_page() {
  global $base_url;

  $drupal_modules = module_list();
  $system_themes = list_themes(TRUE);

  $system_modules = array();
  foreach ($drupal_modules as $name) {
    $path = drupal_get_path('module', $name) . '/' . $name . '.info';
    $info = drupal_parse_info_file($path);
    $system_modules[$info['project']] = $info;
  }

  // Needless initialisation, but hey.
  $res = array(
    "core" => array(),
    "contrib" => array(),
    "custom" => "disabled",
  );

  foreach ($system_modules as $module) {
    if (isset($module['project'])) {
      if ($module['project'] == "drupal") {
        $res['core']['drupal'] = array("version" => $module['version']);
      } else {
        $res['contrib'][$module['project']] = array("version" => $module['version']);
      }
    }
  }

  foreach ($system_themes as $theme) {
    if (isset($theme->info['project']) && $theme->info['project'] == "drupal")
      continue;

    if (isset($theme->info['version']) && isset($theme->info['project']))
      $res['contrib'][$theme->info['project']] = array("version" => $theme->info['version']);
  }

  // Site name.
  $res['site_name'] = variable_get('site_name', $base_url);

  if ((variable_get('warden_need_encryption', 1) == 1) && extension_loaded('mcrypt')) {
    $res = WardenEncryption::encrypt(json_encode(array('warden' => $res)));
    header('Content-Type: application/json');
    echo json_encode(array('warden' => 'encrypted', 'data' => $res, "drupal_version" => "6"));
  }
  else {
    header('Content-Type: application/json');
    echo json_encode(array('warden' => $res, "drupal_version" => "6"));
  }
}
